bl_info = {
    "name": "TESTING ADDON FOR 129405",
    "author": "ALASKA",
    "version": (1, 0, 0),
    "blender": (4, 0, 0),
    "location": "Somewhere",
    "warning": "",
    "description": "Simple testing",
    "doc_url": "",
    "category": "",
}

import os
import bpy

def append_items(blend_file_name, inner_directory, asset_name, scene_name = None):
    blend_path = os.path.join(os.path.dirname(__file__), blend_file_name)
    try:        
        bpy.ops.wm.append(filepath=os.path.join(blend_path, inner_directory, asset_name),
                            directory= os.path.join(blend_path, inner_directory),
                            filename= asset_name,
                            set_fake=False,
                            do_reuse_local_id = True,
                            link=False,
                            use_recursive=True                                
                            )

        bpy.data.libraries.remove(bpy.data.libraries[blend_file_name])
            
    except Exception as e:
        if scene_name is not None:
            report_custom_error.store_error(scene_name,f'Failed to Append {asset_name}. ')
        else:
            print(f'failed to append assets {inner_directory}')
            print(e)
        return False
    return True


def append_and_switch_workspaces():
    workspace_name = "MY_CUSTOM_LAYOUT"
    if workspace_name not in bpy.data.workspaces:
        append_items('custom_file.blend', 'WorkSpace', workspace_name)
        print('appended workspace')

    if bpy.context.window.workspace.name != workspace_name:
        if workspace_name in bpy.data.workspaces:
            print('about to change workspace')
            bpy.context.window.workspace = bpy.data.workspaces[workspace_name]
            print('changed workspace')

    found = 0
    for area in bpy.context.screen.areas:
        if area.type == 'IMAGE_EDITOR':
            found += 1

    print(f"Found this many image editors: {found}")


class SimpleOperator(bpy.types.Operator):
    """Tooltip"""
    bl_idname = "object.simple_operator"
    bl_label = "Simple Object Operator"

    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        append_and_switch_workspaces()
        return {'FINISHED'}


def menu_func(self, context):
    self.layout.operator(SimpleOperator.bl_idname, text=SimpleOperator.bl_label)


def register():
    bpy.utils.register_class(SimpleOperator)
    bpy.types.VIEW3D_MT_object.append(menu_func)


def unregister():
    bpy.utils.unregister_class(SimpleOperator)
    bpy.types.VIEW3D_MT_object.remove(menu_func)


if __name__ == "__main__":
    register()